/****
HidTouch input driver.
(c)2008 David SPORN
 ****/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef HIDTOUCH__HDTRAWDATA__H
#define HIDTOUCH__HDTRAWDATA__H

static void
HdtRawData__fillFromInputInfo__hasNoPacketManagement(HdtRawDataPtr hdtRawData, InputInfoPtr pInfo)
{
    HdtDevicePtr pDevice = pInfo->private;
    HdtConfigurationPtr configuration = &(pDevice->myConfiguration) ;
    HdtOpCodePtr op_code_setup = &(configuration->opCodeSetup) ;

    int i ;
    struct hiddev_event packet ;
    /*int op_code ;
    int op_value ;*/

    for(i=0; i<(configuration->packetCount) ; i++) {
        read(pInfo->fd, &packet, sizeof(packet)) ;
        /*op_code = HdtRawData__fillFromInputInfo__readInt(pInfo) ;*/
        /*op_value = HdtRawData__fillFromInputInfo__readInt(pInfo) ;*/
        /*xf86Msg(X_INFO, "Read packet : \t%x\t%x\n", op_code, op_value);*/

    	/*TODO put the following into a subfunction*/
        if(packet.hid == op_code_setup->pressure)
        {
            hdtRawData->pressure = (0 == packet.value)
                    ? HDT__RAW_DATA__IS_NOT_PRESSED
                    : HDT__RAW_DATA__IS_PRESSED ;
        }
        else if(packet.hid == op_code_setup->x)
        {
            hdtRawData->x = packet.value ;
        }
        else if(packet.hid == op_code_setup->y)
        {
            hdtRawData->y = packet.value ;
        }
    }
}


static void
HdtRawData__fillFromInputInfo__hasPacketManagement__keepOnlyFirstSubgroup(HdtRawDataPtr hdtRawData, InputInfoPtr pInfo)
{
    HdtDevicePtr pDevice = pInfo->private;
    HdtConfigurationPtr configuration = &(pDevice->myConfiguration) ;
    HdtOpCodePtr op_code_setup = &(configuration->opCodeSetup) ;
    HdtPacketManagementPtr packetManagement = &(configuration->packetManagement) ;

    int i ;
    struct hiddev_event packet ;
    /*int op_code ;
    int op_value ;*/

    for(i=0; i<(configuration->packetCount) ; i++) {
        read(pInfo->fd, &packet, sizeof(packet)) ;
        /*op_code = HdtRawData__fillFromInputInfo__readInt(pInfo) ;*/
        /*op_value = HdtRawData__fillFromInputInfo__readInt(pInfo) ;*/
        /*xf86Msg(X_INFO, "Read packet : \t%x\t%x\n", op_code, op_value);*/

        if (i < packetManagement->subgroupPacketCount)
        {
        	/*TODO put the following into a subfunction*/
            if(packet.hid == op_code_setup->pressure)
            {
                hdtRawData->pressure = (0 == packet.value)
                        ? HDT__RAW_DATA__IS_NOT_PRESSED
                        : HDT__RAW_DATA__IS_PRESSED ;
            }
            else if(packet.hid == op_code_setup->x)
            {
                hdtRawData->x = packet.value ;
            }
            else if(packet.hid == op_code_setup->y)
            {
                hdtRawData->y = packet.value ;
            }
        }
    }
}


static void
HdtRawData__fillFromInputInfo(HdtRawDataPtr hdtRawData, InputInfoPtr pInfo)
{
    HdtDevicePtr pDevice = pInfo->private;
    HdtConfigurationPtr configuration = &(pDevice->myConfiguration) ;
    HdtPacketManagementPtr packetManagement = &(configuration->packetManagement) ;

    if (packetManagement->hasSubgroup)
    {
    	/*for now only one strategy available*/
    	HdtRawData__fillFromInputInfo__hasPacketManagement__keepOnlyFirstSubgroup(hdtRawData, pInfo);
    }
    else
    {
    	HdtRawData__fillFromInputInfo__hasNoPacketManagement(hdtRawData, pInfo);
    }

}

#endif /** ifndef HIDTOUCH__HDTRAWDATA__H **/
